## cctools 4.0

=== Makefile ===
include Makefile.config
include Makefile.rules

all clean: Makefile.config
	for p in ${CCTOOLS_PACKAGES} ; do cd $$p && ${MAKE} $@ && cd .. ; done

test: Makefile.config
	./run_all_tests.sh

install: all Makefile.config
	for p in ${CCTOOLS_PACKAGES} ; do cd $$p && ${MAKE} $@ && cd .. ; done
	mkdir -p ${CCTOOLS_INSTALL_DIR}/etc
	cp Makefile.config ${CCTOOLS_INSTALL_DIR}/etc/Makefile.config
	cp COPYING ${CCTOOLS_INSTALL_DIR}/doc

Makefile.config:
	@echo "You must run 'configure' before '${MAKE}'."
	@exit 1

=== allpairs/Makefile ===
include ../Makefile.config
include ../Makefile.rules

all test install clean:
	for p in src test; do cd $$p && $(MAKE) $@ && cd .. ; done

.PHONY: all install test clean

=== doc/Makefile ===
include ../Makefile.config

SOURCES=${shell ls man/*.m4}

HTMLFILES = ${SOURCES:%.m4=%.html}
TXTFILES = ${SOURCES:%.m4=%.txt}
PDFFILES = ${SOURCES:%.m4=%.pdf}
MANFILES = ${SOURCES:%.m4=%.1}
ZIPFILES = ${SOURCES:%.m4=%.1.gz}

all: ${CCTOOLS_DOCTARGETS}

htmlpages: ${HTMLFILES}

manpages: ${ZIPFILES}

apipages: api/html/index.html

api/html/index.html:
	doxygen cctools.doxygen.config

%.html: %.m4
	m4 -DHTML ${CCTOOLS_M4_ARGS} $< > $@

%.1: %.m4
	m4 -DMAN ${CCTOOLS_M4_ARGS} $< > $@

%.txt: %.1
	nroff -man $< > $@

%.gz: %
	gzip < $< > $@

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc/man
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc/images
	mkdir -p $(CCTOOLS_INSTALL_DIR)/share/man/man1
	cp *.html $(CCTOOLS_INSTALL_DIR)/doc
	if [ -f man/chirp.html ]; then cp man/*.html $(CCTOOLS_INSTALL_DIR)/doc/man; fi
	if [ -f man/chirp.1.gz ]; then cp man/*.1.gz $(CCTOOLS_INSTALL_DIR)/share/man/man1; fi
	if [ -d api ]; then cp -rp api $(CCTOOLS_INSTALL_DIR)/doc; fi
	if [ -d images ]; then cp images/*.gif $(CCTOOLS_INSTALL_DIR)/doc/images; fi

test:

clean:
	rm -rf api $(HTMLFILES) $(MANFILES) $(ZIPFILES) *~

=== ftp_lite/Makefile ===
include ../Makefile.config
include ../Makefile.rules

all test install clean:
	for p in src ; do cd $$p && $(MAKE) $@ && cd .. ; done

=== parrot/Makefile ===
include ../Makefile.config
include ../Makefile.rules

all test install clean:
	for p in src; do cd $$p && $(MAKE) $@ && cd .. ; done

=== resource_monitor_visualizer/Makefile ===
include ../Makefile.config
include ../Makefile.rules

SCRIPT = bin/resource_monitor_visualizer.py

test:

all:

clean:

uninstall:
	rm -rf ${CCTOOLS_INSTALL_DIR}/lib/resource_monitor_visualizer_static
	rm -f ${CCTOOLS_INSTALL_DIR}/${SCRIPT}

install:
	mkdir -p ${CCTOOLS_INSTALL_DIR}/bin
	mkdir -p ${CCTOOLS_INSTALL_DIR}/lib
	chmod 755 ${SCRIPT}
	cp ${SCRIPT} ${CCTOOLS_INSTALL_DIR}/bin
	cp -r lib/* ${CCTOOLS_INSTALL_DIR}/lib/

=== wavefront/Makefile ===
include ../Makefile.config
include ../Makefile.rules

all test install clean:
	for p in src ; do cd $$p && $(MAKE) $@ && cd .. ; done

.PHONY: all install test clean

=== work_queue/Makefile ===
include ../Makefile.config
include ../Makefile.rules

all test install clean:
	@for p in src; do cd $$p && $(MAKE) $@ && cd .. ; done

.PHONY: all test install clean

=== allpairs/src.tpds/Makefile ===
CCTOOLS_HOME = ../../../

include ${CCTOOLS_HOME}/Makefile.config
include ${CCTOOLS_HOME}/Makefile.rules

TARGETS = allpairs allpairs_status allpairs_wait allpairs_cleanup

LOCAL_LDFLAGS=-lchirp -ldttools ${CCTOOLS_INTERNAL_LDFLAGS}

all: ${TARGETS}

allpairs: allpairs.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS} -lm #-lefence

allpairs_status: allpairs_status.o ${CCTOOLS_HOME}/chirp/src/libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

allpairs_wait: allpairs_wait.o ${CCTOOLS_HOME}/chirp/src/libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

allpairs_cleanup: allpairs_cleanup.o ${CCTOOLS_HOME}/chirp/src/libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

test:

clean:
	rm -f core *~ *.o *.a ${TARGETS} 

install: all
	mkdir -p ${CCTOOLS_INSTALL_DIR}/bin
	cp allpairs ${CCTOOLS_INSTALL_DIR}/bin
	cp allpairs_wait ${CCTOOLS_INSTALL_DIR}/bin
	cp allpairs_status ${CCTOOLS_INSTALL_DIR}/bin
	cp allpairs_cleanup ${CCTOOLS_INSTALL_DIR}/bin	
	cp allpairs_wrapper.sh ${CCTOOLS_INSTALL_DIR}/bin

=== allpairs/src/Makefile ===
CCTOOLS_HOME = ../../

include ${CCTOOLS_HOME}/Makefile.config
include ${CCTOOLS_HOME}/Makefile.rules

TARGETS = allpairs_multicore allpairs_master

LOCAL_LDFLAGS=../../sand/src/libsandtools.a -lwork_queue -ldttools ${CCTOOLS_INTERNAL_LDFLAGS}

all: ${TARGETS}

allpairs_multicore: allpairs_multicore.o allpairs_compare.o ${CCTOOLS_HOME}/dttools/src/libdttools.a
	${CCTOOLS_LD} -o $@ allpairs_multicore.o allpairs_compare.o -lpthread ${LOCAL_LDFLAGS}

allpairs_master: allpairs_master.o allpairs_compare.o ${CCTOOLS_HOME}/dttools/src/libdttools.a
	${CCTOOLS_LD} -o $@ allpairs_master.o allpairs_compare.o ${LOCAL_LDFLAGS}

test:

clean:
	rm -f core *~ *.o *.a ${TARGETS} 

install: all
	mkdir -p ${CCTOOLS_INSTALL_DIR}/bin
	cp ${TARGETS} ${CCTOOLS_INSTALL_DIR}/bin

=== allpairs/test/Makefile ===
CCTOOLS_HOME = ../..

include ${CCTOOLS_HOME}/Makefile.config
include ${CCTOOLS_HOME}/Makefile.rules

all:

test:
	@echo running allpairs tests
	@${CCTOOLS_HOME}/dttools/src/test_runner.sh TR_*.sh

clean:

install:

=== apps/replica_exchange_protomol/Makefile ===

include ../../Makefile.config
include ../../Makefile.rules

all:

test:

install:
	cp protomol_functions.py ${CCTOOLS_INSTALL_DIR}/bin
	cp replica_exchange.py ${CCTOOLS_INSTALL_DIR}/bin

clean:

=== debian/changelog ===
cctools (4.0-3build1) cosmic; urgency=medium

  * No-change rebuild for dune openmpi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 13 May 2018 16:59:54 +0000

cctools (4.0-3) unstable; urgency=medium

  * Adopting cctools. (Closes: #889130)
  * Get mpi path from pkg-config. don't assume /usr/include/mpi/mpi.h
    which breaks on openmpi 

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 16 Apr 2018 09:12:01 +0100

cctools (4.0-2) unstable; urgency=medium

  * QA upload.
  * Set maintainer to the QA team.
  * Fix FTBFS with glibc 2.26, patch by Juhani Numminen.  (Closes: #887763)
  * Drop debian/patches/multiarch_configure -- upstreamed and unused.
  * Priority optional.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 03 Feb 2018 04:30:36 +0100

cctools (4.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Switch Build-Depends to default-libmysqlclient-dev.  (Closes: #845828)
  * Fix typo in description.  (Closes: #749777)

 -- Andreas Beckmann <anbe@debian.org>  Thu, 12 Jan 2017 17:16:40 +0100

cctools (4.0-1) unstable; urgency=low

  * New upstream release (missed quite a few).
    - Fix FD_CLOEXEC file descriptor flag setting (Closes: #696249).
  * Disabled now obsolete patches (run_tests_on_buildd, parrot_run_hang_fix).
  * Bump debhelper compat level to 9, to enable hardening.
  * Disable API doc generation via doxygen for now -- to avoid delaying this
    overdue upload even longer. The problem of hanging doxygen remains, but is
    now hidden (Closes: #718092).
  * Add patch to use bash as interpreter for ec2_remove_workers -- contains
    bash-specific for loop construct.

 -- Michael Hanke <mih@debian.org>  Mon, 29 Jul 2013 18:55:40 +0200

=== debian/control ===
Source: cctools
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 9~), python-all-dev (>= 2.6.6-3~),
  libglobus-common-dev,
  default-libmysqlclient-dev,
  libfuse-dev,
  libkrb5-dev,
  pkg-config,
  libglobus-gss-assist-dev, net-tools, doxygen,
  libreadline6-dev | libreadline-dev, libncurses5-dev | libncurses-dev, swig,
  m4, mpi-default-dev
Standards-Version: 4.1.3
Homepage: http://nd.edu/~ccl/software/
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/cctools.git
Vcs-Git: git://git.debian.org/git/pkg-exppsy/cctools.git

Package: coop-computing-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python
Suggests: coop-computing-tools-doc, condor, gridengine-client
Description: cooperative computing tools
 This is a collection of software that help users to share resources in a
 complex, heterogeneous, and unreliable computing environment. This includes:
 .
  * Chirp: A personal filesystem and I/O protocol that allows unprivileged users
    to share space securely, efficiently, and conveniently. When combined
    with Parrot, Chirp allows users to create custom wide-area
    distributed filesystems.
  * Parrot: A transparent user-level virtual filesystem that allows any ordinary
    program to be attached to a remote storage device such as an FTP
    server or a Chirp server.
  * Makeflow: A workflow system for parallel and distributed computing that uses
    a language very similar to Make.
  * Work Queue: A system and API for building master-worker style programs that
    scale up to thousands of processors.
  * All Pairs: A computational abstraction for running very large Cartesian
    products.
  * Wavefront: A computational abstraction for running very large dynamic
    programming problems.
  * The Fault Tolerant Shell: A high-level programming language that allows
    users to combine the ease of shell scripting, the power of distributed
    programming, and the precision of compiled languages. Basically,
    parallel programming and exception handling for scripts.

Package: coop-computing-tools-dev
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: libraries and header files for coop-computing-tools
 These tools are a collection of software that help users to share resources in
 a complex, heterogeneous, and unreliable computing environment.
 .
 This package provides static libraries and header files for development.

Package: coop-computing-tools-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-jquery
Description: documentation for coop-computing-tools
 These tools are a collection of software that help users to share resources in
 a complex, heterogeneous, and unreliable computing environment.
 .
 This package provides the documentation (manual and API reference) in HTML
 format.

Package: python-workqueue
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Description: cooperative computing tools work queue Python bindings
 CCTools's Work Queue is a system and API for building master-worker style
 programs that scale up to thousands of processors. This package provides
 bindings to access this system from Python.

=== debian/rules ===
#!/usr/bin/make -f

non_default_python_versions = $(shell python -c "print \"`pyversions -v -s`\".replace(\"`pyversions -v -d`\", '').strip()")

# one ring to rule them all ...
%:
	dh $@ --buildsystem=makefile --with python2

override_dh_auto_configure:
	# disable warning about unused results (necessary because warning is error
	# is ON)
	CFLAGS="$(CFLAGS) -Wno-unused-result" ./configure --with-globus-path /usr \
		--with-mysql-path /usr --with-krb5-path /usr --with-readline-path /usr \
		--with-mpi-path /usr --with-fuse-path /usr --with-zlib-path /usr \
		--with-python-path /usr

override_dh_auto_test:
	# disable the tests for now on upstream's request. they will be reenabled
	# once the test suite can properly deal with the buildd environment

override_dh_auto_install:
	dh_auto_install -- CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp
	# make extensions for other supported python versions
	if [ -n "$(non_default_python_versions)" ]; then \
		for pyver in $(non_default_python_versions); do \
			PYTHON=/usr/bin/python$${pyver} ./configure.rerun ; \
			make -B -C work_queue/src/python install CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp ; \
		done ; \
	fi
	# for now remove the 'apps' scripts till upstream confirms that the language
	# extension can be removed
	rm -f debian/tmp/bin/*.py
	# fix permissions
	find debian/tmp/lib -name '*.py' -exec chmod 644 {} \;
	# remove undesired pieces
	-rm debian/tmp/doc/COPYING
	# upstream says it should not go into the page
	-rm debian/tmp/bin/watchdog
	# HDFS helpers are useless without HDFS in Debian
	-rm debian/tmp/bin/*_hdfs
	# newer doxygen puts jquery copy
	#-rm debian/tmp/doc/api/html/jquery.js

override_dh_auto_clean:
	[ -e Makefile.config ] && dh_auto_clean || true
	-rm Makefile.config configure.rerun
	-rm -rf api hdfs-setup.template python/python-workqueue/setup.cfg
	# remove testrun left-overs
	-rm dttools/src/microbench dttools/src/work_queue_example
	-find $(CURDIR) -name '*.test.log' -delete
	-find $(CURDIR) -name '*_test' -delete
	-rm -rf sand/test/filter_verification/random.cand.filter.tmp/
	-rm -rf sand/test/test_20.cand.filter.tmp/
	-rm -f sand/test/test_20.cand sand/test/test_20.cfa sand/test/*.log
	-rm -rf makeflow/test/input/ makeflow/test/worker.pid
	-rm -rf makeflow/test/dirs/testcase.subdir.01.makeflow.makeflowlog
	-rm -rf makeflow/test/dirs/testcase.subdir.01.makeflow.wqlog
	-rm -rf makeflow/test/src/
	-rm dttools/src/multirun sand/test/banded.log
	-rm .configure.tmp.o

## cctools 6.2.9

=== batch_job/src/Makefile ===
include ../../config.mk
include ../../rules.mk

LIBRARIES = libbatch_job.a

PROGRAMS = work_queue_factory work_queue_pool

ifeq ($(CCTOOLS_CHIRP),chirp)
CHIRP_LIB=../../chirp/src/libchirp.a
CHIRP_BATCH=batch_job_chirp.c
endif

EXTERNAL_LIBRARIES = ../../work_queue/src/libwork_queue.a $(CHIRP_LIB) ../../dttools/src/libdttools.a

SOURCES = \
	batch_job.c \
	batch_job_amazon.c \
	batch_job_dryrun.c \
	$(CHIRP_BATCH) \
	batch_job_cluster.c \
	batch_job_blue_waters.c \
	batch_job_condor.c \
	batch_job_local.c \
	batch_job_work_queue.c\
	batch_job_mesos.c \
	mesos_task.c

PUBLIC_HEADERS = batch_job.h

OBJECTS = $(SOURCES:%.c=%.o)

all: $(LIBRARIES) $(PROGRAMS)

libbatch_job.a: $(OBJECTS)

work_queue_factory: work_queue_factory.o libbatch_job.a $(EXTERNAL_LIBRARIES)

# Note that work_queue_pool is the same as work_queue_factory, for backwards compatibility.
work_queue_pool: work_queue_factory
	cp $< $@

install:
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(PUBLIC_HEADERS) $(CCTOOLS_INSTALL_DIR)/include/cctools

clean:
	rm -rf $(OBJECTS) $(LIBRARIES) $(PROGRAMS) batch_job_amazon_script.c *.o

=== chirp/src/Makefile ===
include ../../config.mk
include ../../rules.mk

# -DSQLITE_DEFAULT_MMAP_SIZE=1073741824 - allow mmap of database.
# -DSQLITE_TEMP_STORE=3 - only use memory for temporary files.
# -DSQLITE_THREADSAFE=0 - we only use sqlite3 multi-process (i.e. no threads). This disables somewhat costly mutex locks.
LOCAL_CCFLAGS = -DSQLITE_DEFAULT_MMAP_SIZE=1073741824 -DSQLITE_TEMP_STORE=3 -DSQLITE_THREADSAFE=0 -fstack-protector-all

# Globus is needed by all executables via libdttools.a/auth_globus.o
LOCAL_LINKAGE = $(CCTOOLS_GLOBUS_LDFLAGS)

EXTERNAL_DEPENDENCIES = ../../dttools/src/libdttools.a
LIBRARIES = libchirp.a libconfuga.a
OBJECTS = chirp_tool.o chirp_fuse.o $(OBJECTS_CONFUGA) $(OBJECTS_LIBRARY) $(OBJECTS_SERVER)
OBJECTS_CONFUGA = $(SOURCES_CONFUGA:%.c=%.o)
OBJECTS_LIBRARY = $(SOURCES_LIBRARY:%.c=%.o)
OBJECTS_SERVER = $(SOURCES_SERVER:%.c=%.o)
PROGRAMS = $(PROGRAMS_CHIRP) $(PROGRAMS_CONFUGA)
PROGRAMS_CHIRP = chirp chirp_get chirp_put chirp_server chirp_status chirp_benchmark chirp_stream_files chirp_fuse chirp_distribute
PROGRAMS_CONFUGA = confuga_adm
PUBLIC_HEADERS = chirp_global.h chirp_multi.h chirp_reli.h chirp_client.h chirp_stream.h chirp_protocol.h chirp_matrix.h chirp_types.h chirp_recursive.h confuga.h
SCRIPTS = chirp_audit_cluster chirp_server_hdfs
SOURCES_CONFUGA = confuga.c confuga_namespace.c confuga_replica.c confuga_node.c confuga_job.c confuga_file.c confuga_gc.c
SOURCES_LIBRARY = chirp_global.c chirp_multi.c chirp_recursive.c chirp_reli.c chirp_client.c chirp_matrix.c chirp_stream.c chirp_ticket.c
SOURCES_SERVER = sqlite3.c chirp_stats.c chirp_thirdput.c chirp_alloc.c chirp_audit.c chirp_acl.c chirp_group.c chirp_filesystem.c chirp_fs_hdfs.c chirp_fs_local.c chirp_fs_local_scheduler.c chirp_fs_chirp.c chirp_fs_confuga.c chirp_job.c chirp_sqlite.c
TARGETS = $(PROGRAMS) $(LIBRARIES) bindings

all: $(TARGETS)

chirp: chirp_tool.o
	$(CCTOOLS_LD) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LDFLAGS) $^ $(LOCAL_LINKAGE) $(CCTOOLS_READLINE_LDFLAGS) $(CCTOOLS_EXTERNAL_LINKAGE) $(CCTOOLS_READLINE_LDFLAGS)

chirp_fuse: chirp_fuse.o
	$(CCTOOLS_LD) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LDFLAGS) $^ $(LOCAL_LINKAGE) $(CCTOOLS_FUSE_LDFLAGS) $(CCTOOLS_EXTERNAL_LINKAGE)

chirp_fuse.o: chirp_fuse.c
	$(CCTOOLS_CC) -o $@ -c $(CCTOOLS_INTERNAL_CCFLAGS) $(LOCAL_CCFLAGS) $(CCTOOLS_FUSE_CCFLAGS) $<

chirp_job.o chirp_fs_local_scheduler.o: chirp_sqlite.h

# This is the library intended to be used by clients of the system.
libchirp.a: $(OBJECTS_LIBRARY)

confuga.o confuga_job.o confuga_namespace.o confuga_node.o confuga_replica.o confuga_file.o: confuga.h confuga_fs.h chirp_sqlite.h
libconfuga.a: $(OBJECTS_CONFUGA) $(OBJECTS_LIBRARY) chirp_sqlite.o sqlite3.o
libconfuga.$(CCTOOLS_DYNAMIC_SUFFIX): $(OBJECTS_CONFUGA) ../../dttools/src/auth_all.o $(EXTERNAL_DEPENDENCIES)

chirp_server: $(OBJECTS_SERVER) libconfuga.a
$(PROGRAMS_CONFUGA): libconfuga.a libchirp.a $(EXTERNAL_DEPENDENCIES)
$(PROGRAMS_CHIRP): libchirp.a $(EXTERNAL_DEPENDENCIES)
$(CCTOOLS_SWIG_BINDINGS): libchirp.a $(EXTERNAL_DEPENDENCIES)

bindings: $(CCTOOLS_SWIG_BINDINGS)
$(CCTOOLS_SWIG_BINDINGS): chirp_swig_wrap.o
	@$(MAKE) -C $@

CCTOOLS_SWIG_BINDINGS_INSTALL = $(CCTOOLS_SWIG_BINDINGS:%=install-%)
install-bindings: $(CCTOOLS_SWIG_BINDINGS_INSTALL)
$(CCTOOLS_SWIG_BINDINGS_INSTALL): $(CCTOOLS_SWIG_BINDINGS)
	@$(MAKE) -C $(@:install-%=%) install

CCTOOLS_SWIG_BINDINGS_CLEAN = $(CCTOOLS_SWIG_BINDINGS:%=clean-%)
clean-bindings: $(CCTOOLS_SWIG_BINDINGS_CLEAN)
$(CCTOOLS_SWIG_BINDINGS_CLEAN):
	@$(MAKE) -C $(@:clean-%=%) clean

clean: clean-bindings
	rm -f $(OBJECTS) $(TARGETS)

install: all install-bindings
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	if [ -f $(CCTOOLS_INSTALL_DIR)/bin/chirp_server ]; then mv $(CCTOOLS_INSTALL_DIR)/bin/chirp_server $(CCTOOLS_INSTALL_DIR)/bin/chirp_server.old; fi
	chmod 755 $(SCRIPTS)
	cp $(PROGRAMS) $(SCRIPTS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(PUBLIC_HEADERS) $(CCTOOLS_INSTALL_DIR)/include/cctools/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/share/cctools/chirp/
	cp -r ../tools/workflows/ $(CCTOOLS_INSTALL_DIR)/share/cctools/chirp/

test: all

.PHONY: all clean install test $(CCTOOLS_SWIG_BINDINGS) bindings $(CCTOOLS_SWIG_BINDINGS_INSTALL) install-bindings $(CCTOOLS_SWIG_BINDINGS_CLEAN) clean-bindings

=== chirp/src/python/Makefile ===
include ../../../config.mk
include ../../../rules.mk

# Python always uses 'so' for its modules (even on Darwin)
CCTOOLS_DYNAMIC_SUFFIX = so
# SWIG produces code that causes a lot of warnings, so use -w to turn those off.
LOCAL_CCFLAGS = -fPIC -w $(CCTOOLS_PYTHON_CCFLAGS)
LOCAL_LINKAGE = $(CCTOOLS_PYTHON_LDFLAGS) $(CCTOOLS_GLOBUS_LDFLAGS) $(CCTOOLS_EXTERNAL_LINKAGE)

EXTERNAL_DEPENDENCIES = ../libchirp.a ../../../dttools/src/libdttools.a
CHIRPPYTHONSO = _CChirp.$(CCTOOLS_DYNAMIC_SUFFIX)
LIBRARIES = $(CHIRPPYTHONSO)
OBJECTS = chirp_wrap.o ../chirp_swig_wrap.o
TARGETS = Chirp.py $(LIBRARIES)

all: $(TARGETS)

Chirp.py: chirp_wrap.c CChirp.py

# The odd symlink in the following rule is necessary to overcome a problem
# in the framework search path emitted by the Python configuration on macOS.
chirp_wrap.c CChirp.py: chirp.i chirp.binding.py
	@echo "SWIG chirp.i (python)"
	@$(CCTOOLS_SWIG) -o chirp_wrap.c -python -I../../../dttools/src/ -I../ chirp.i
	@cat CChirp.py > Chirp.py
	@cat chirp.binding.py >> Chirp.py
	ln -sf /System/Library/Frameworks/Python.framework .

$(CHIRPPYTHONSO): $(OBJECTS) $(EXTERNAL_DEPENDENCIES)

clean:
	rm -f $(OBJECTS) $(TARGETS) Python.framework Chirp.py CChirp.py chirp_wrap.c *.pyc

test:

install: all
	mkdir -p $(CCTOOLS_PYTHON_PATH)
	cp Chirp.py $(CHIRPPYTHONSO) $(CCTOOLS_PYTHON_PATH)/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc
	cp chirp_python_example.py $(CCTOOLS_INSTALL_DIR)/doc/

=== work_queue/src/perl/Makefile ===
include ../../../config.mk
include ../../../rules.mk

PERL_INSTALL_DIR = $(CCTOOLS_INSTALL_DIR)/lib/perl5/site_perl/$(CCTOOLS_PERL_VERSION)

# SWIG produces code that causes a lot of warnings, so use -w to turn those off.
# Perl also defines some HAS_* stuff so we need to undefine those too.
LOCAL_CCFLAGS = -w -UHAS_USLEEP -UHAS_ISNAN -UHAS_UTIME -fPIC -Wno-unused-value -Wno-unused-variable $(CCTOOLS_PERL_CCFLAGS)
LOCAL_LINKAGE = $(CCTOOLS_PERL_LDFLAGS) -lz

EXTERNAL_DEPENDENCIES = ../libwork_queue.a ../../../dttools/src/libdttools.a
WQPERLSO = work_queue.$(CCTOOLS_DYNAMIC_SUFFIX)
LIBRARIES = work_queue.pm $(WQPERLSO)
OBJECTS = work_queue_wrap.o
TARGETS = $(LIBRARIES)

all: $(TARGETS)

work_queue_wrap.c work_queue.pm: work_queue.i $(EXTERNAL_DEPENDENCIES)
	@echo "SWIG work_queue.i (perl5)"
	@$(CCTOOLS_SWIG) -o work_queue_wrap.c -perl5 -exportall -I../../../dttools/src -I../ work_queue.i

$(WQPERLSO): $(OBJECTS) $(EXTERNAL_DEPENDENCIES)

clean:
	rm -f $(OBJECTS) $(TARGETS) *.o work_queue_wrap.c

test: all

install: all
	mkdir -p $(PERL_INSTALL_DIR)
	cp $(LIBRARIES)       $(PERL_INSTALL_DIR)/
	mkdir -p              $(PERL_INSTALL_DIR)/Work_Queue
	cp Work_Queue.pm      $(PERL_INSTALL_DIR)
	cp Work_Queue/Task.pm $(PERL_INSTALL_DIR)/Work_Queue
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc
	chmod 755 work_queue_example.pl
	cp work_queue_example.pl $(CCTOOLS_INSTALL_DIR)/doc/

=== debian/changelog ===
cctools (6.2.9-2) unstable; urgency=medium

  * Add path for Hurd support

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 10 Jun 2018 08:44:11 +0100

cctools (6.2.9-1) experimental; urgency=medium

  * New upstream release
  * Refresh patches:
    - remove handle_bashism
    - remove missing_includes
  * Provide python3-workqueue package
  * Update homepage to https version
  * Set coop-computing-tools-doc as M-A: foreign
  * Change VCS paths to salsa.d.o
  * Standards-Version: 4.1.4
  * libperl-dev now needed to build
  * Add new manpages
  * B-D on libsqlite3-dev. Use this rather than embedded copy 

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 22 May 2018 08:47:14 +0100

=== debian/control ===
--- 
+++ 
@@ -2,19 +2,26 @@
 Section: utils
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper (>= 9~), python-all-dev (>= 2.6.6-3~),
+Build-Depends: debhelper (>= 10), 
+  python-all-dev (>= 2.6.6-3~),
+  python3-all-dev, 
   libglobus-common-dev,
   default-libmysqlclient-dev,
   libfuse-dev,
+  libperl-dev,
   libkrb5-dev,
+  libsqlite3-dev,
   pkg-config,
   libglobus-gss-assist-dev, net-tools, doxygen,
-  libreadline6-dev | libreadline-dev, libncurses5-dev | libncurses-dev, swig,
-  m4, mpi-default-dev
-Standards-Version: 4.1.3
-Homepage: http://nd.edu/~ccl/software/
-Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/cctools.git
-Vcs-Git: git://git.debian.org/git/pkg-exppsy/cctools.git
+  libreadline6-dev | libreadline-dev, 
+  libncurses5-dev | libncurses-dev, 
+  swig,
+  m4, 
+  mpi-default-dev
+Standards-Version: 4.1.4
+Homepage: https://ccl.cse.nd.edu/software/
+Vcs-Browser: https://salsa.debian.org:/neurodebian-team/cctools.git
+Vcs-Git: https://salsa.debian.org:/neurodebian-team/cctools.git
 
 Package: coop-computing-tools
 Architecture: any
@@ -57,6 +64,7 @@
 Package: coop-computing-tools-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}, libjs-jquery
 Description: documentation for coop-computing-tools
  These tools are a collection of software that help users to share resources in
@@ -68,8 +76,17 @@
 Package: python-workqueue
 Section: python
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python
 Description: cooperative computing tools work queue Python bindings
  CCTools's Work Queue is a system and API for building master-worker style
  programs that scale up to thousands of processors. This package provides
  bindings to access this system from Python.
+
+Package: python3-workqueue
+Section: python
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3
+Description: cooperative computing tools work queue Python3 bindings
+ CCTools's Work Queue is a system and API for building master-worker style
+ programs that scale up to thousands of processors. This package provides
+ bindings to access this system from Python3.

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 # one ring to rule them all ...
 %:
-	dh $@ --buildsystem=makefile --with python2
+	dh $@ --buildsystem=makefile --with python2,python3
 
 override_dh_auto_configure:
 	# disable warning about unused results (necessary because warning is error

## cctools 6.2.10

=== dttools/src/Makefile ===
include ../../config.mk
include ../../rules.mk

SOURCES = \
	address.c \
	auth.c \
	auth_address.c \
	auth_all.c \
	auth_globus.c \
	auth_hostname.c \
	auth_kerberos.c \
	auth_ticket.c \
	auth_unix.c \
	b64.c \
	bitmap.c \
	buffer.c \
	catalog_query.c \
	category.c \
	cctools.c \
	change_process_title.c \
	chunk.c \
	clean_dir.c \
	compat-at.c \
	console_login.c \
	copy_stream.c \
	copy_tree.c \
	create_dir.c \
	daemon.c \
	datagram.c \
	debug.c \
	debug_file.c \
	debug_journal.c \
	debug_stream.c \
	debug_syslog.c \
	disk_alloc.c \
	domain_name.c \
	domain_name_cache.c \
	dpopen.c \
	elfheader.c \
	envtools.c \
	fast_popen.c \
	fd.c \
	file_cache.c \
	full_io.c \
	get_canonical_path.c \
	get_line.c \
	getopt.c \
	getopt_aux.c \
	gpu_info.c \
	hash_cache.c \
	hash_table.c \
	hdfs_library.c \
	histogram.c \
	hmac.c \
	host_disk_info.c \
	host_memory_info.c \
	http_query.c \
	interfaces_address.c \
	itable.c \
	json.c \
	json_aux.c \
	jx.c \
	jx_database.c \
	jx_match.c \
	jx_parse.c \
	jx_print.c \
	jx_pretty_print.c \
	jx_table.c \
	jx_export.c \
	jx_eval.c \
	jx_function.c \
	link.c \
	link_auth.c \
	list.c \
	load_average.c \
	md5.c \
	memfdexe.c \
	mergesort.c \
	mkdir_recursive.c \
	twister.c \
	nvpair.c \
	nvpair_jx.c \
	password_cache.c \
	path.c \
	path_disk_size_info.c \
	pattern.c \
	preadwrite.c \
	process.c \
	random.c \
	rmonitor.c \
	rmonitor_poll.c \
	rmsummary.c \
	set.c \
	sha1.c \
	shell.c \
	sigdef.c \
	sleeptools.c \
	sort_dir.c \
	stats.c \
	string_array.c \
	stringtools.c \
	text_array.c \
	text_list.c \
	timer.c \
	timestamp.c \
	unlink_recursive.c \
	uptime.c \
	url_encode.c \
	username.c \
	uuid.c \
	xxmalloc.c

HEADERS_PUBLIC = \
	auth.h \
	auth_address.h \
	auth_all.h \
	auth_globus.h \
	auth_hostname.h \
	auth_kerberos.h \
	auth_ticket.h \
	auth_unix.h \
	buffer.h \
	category.h \
	copy_tree.h \
	debug.h \
	hash_table.h \
	histogram.h \
	http_query.h \
	int_sizes.h \
	jx.h \
	jx_match.h \
	link.h \
	md5.h \
	rmonitor_poll.h \
	rmsummary.h \
	timestamp.h

LIBRARIES = libdttools.a
PRELOAD_LIBRARIES = libforce_halt_enospc.so
OBJECTS = $(SOURCES:%.c=%.o)

#separate, because catalog_query has a slightly different order of linking.
MOST_PROGRAMS = catalog_update catalog_server watchdog disk_allocator jx2json
PROGRAMS = $(MOST_PROGRAMS) catalog_query

SCRIPTS = cctools_gpu_autodetect cctools_python
TARGETS = $(LIBRARIES) $(PRELOAD_LIBRARIES) $(PROGRAMS) $(TEST_PROGRAMS)
TEST_PROGRAMS = auth_test disk_alloc_test jx_test microbench multirun jx_count_obj_test histogram_test category_test

all: $(TARGETS) catalog_query

libdttools.a: $(OBJECTS)

$(MOST_PROGRAMS) $(TEST_PROGRAMS): libdttools.a

catalog_query: catalog_query.o catalog_query_tool.o libdttools.a

auth_globus.o: auth_globus.c
	$(CCTOOLS_CC) -o $@ -c $(CCTOOLS_INTERNAL_CCFLAGS) $(LOCAL_CCFLAGS) $(CCTOOLS_GLOBUS_CCFLAGS) $<

auth_test: auth_test.o libdttools.a
ifeq ($(CCTOOLS_STATIC),1)
	@echo "auth_test currently cannot be build statically."
else
	$(CCTOOLS_LD) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LDFLAGS) $^ $(LOCAL_LINKAGE) $(CCTOOLS_GLOBUS_LDFLAGS) $(CCTOOLS_EXTERNAL_LINKAGE)
endif

libforce_halt_enospc.so: libforce_halt_enospc.o
	$(CCTOOLS_CC) -shared -fPIC $^ -o $@ -ldl

clean:
	rm -f $(OBJECTS) $(TARGETS) *.o

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(SCRIPTS) $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(PRELOAD_LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(HEADERS_PUBLIC) $(CCTOOLS_INSTALL_DIR)/include/cctools/

test: all

.PHONY: all clean install test

# vim: set noexpandtab tabstop=4:

=== makeflow/src/Makefile ===
include ../../config.mk
include ../../rules.mk

# makeflow must link against globus:
# makeflow -> batch_job -> batch_job_chirp -> auth -> auth_globus -> globus
LOCAL_LINKAGE=$(CCTOOLS_GLOBUS_LDFLAGS)

EXTERNAL_DEPENDENCIES = ../../batch_job/src/libbatch_job.a ../../work_queue/src/libwork_queue.a ../../chirp/src/libchirp.a ../../dttools/src/libdttools.a
OBJECTS = dag.o dag_node.o dag_file.o dag_variable.o dag_visitors.o dag_resources.o lexer.o parser.o parser_jx.o
PROGRAMS = makeflow makeflow_viz makeflow_analyze makeflow_linker makeflow_status
SCRIPTS = condor_submit_makeflow makeflow_graph_log makeflow_monitor starch makeflow_linker_perl_driver makeflow_linker_python_driver makeflow_archive_query mf_mesos_scheduler mf_mesos_executor mf_mesos_setting mf-mesos-executor makeflow_ec2_setup makeflow_ec2_cleanup

TARGETS = $(PROGRAMS)

all: $(TARGETS)

makeflow makeflow_viz makeflow_analyze makeflow_status: $(OBJECTS)

makeflow_status: makeflow_status.o

makeflow: makeflow_summary.o makeflow_gc.o makeflow_log.o makeflow_wrapper.o makeflow_wrapper_monitor.o makeflow_wrapper_docker.o makeflow_wrapper_enforcement.o makeflow_catalog_reporter.o makeflow_wrapper_umbrella.o makeflow_mounts.o makeflow_wrapper_singularity.o makeflow_archive.o makeflow_local_resources.o

$(PROGRAMS): $(EXTERNAL_DEPENDENCIES)

lexer_test: dag.o dag_visitors.o makeflow_common.o lexer_test.o $(EXTERNAL_DEPENDENCIES)

lexer_test.o: lexer.c
	$(CCTOOLS_CC) -DLEXER_TEST -o $@ -c $(CCTOOLS_INTERNAL_CCFLAGS) $(LOCAL_CCFLAGS) $<

clean:
	rm -f *.o $(TARGETS) lexer_test*

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	chmod 755 $(SCRIPTS)
	cp $(PROGRAMS) $(SCRIPTS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/share/cctools/
	cp style.xml $(CCTOOLS_INSTALL_DIR)/share/cctools/makeflow-cytoscape-style.xml

test: all

.PHONY: all clean install test

=== parrot/src/Makefile ===
include ../../config.mk
include ../../rules.mk

EXTERNAL_DEPENDENCIES = ../../ftp_lite/src/libftp_lite.a ../../chirp/src/libchirp.a ../../grow/src/grow.o ../../dttools/src/libdttools.a
LIBRARIES = libparrot_helper.$(CCTOOLS_DYNAMIC_SUFFIX) libparrot_client.a
OBJECTS = $(OBJECTS_PARROT_RUN) parrot_client.o pfs_resolve_mount.o
OBJECTS_PARROT_RUN = pfs_main.o tracer.o pfs_paranoia.o pfs_dispatch.o pfs_dispatch64.o pfs_process.o pfs_channel.o pfs_sys.o pfs_time.o pfs_table.o pfs_resolve.o pfs_mountfile.o pfs_service.o pfs_file.o pfs_file_cache.o pfs_dir.o pfs_dircache.o pfs_pointer.o pfs_location.o ibox_acl.o pfs_service_local.o pfs_service_http.o pfs_service_grow.o pfs_service_chirp.o pfs_service_multi.o pfs_service_nest.o pfs_service_ftp.o pfs_service_irods.o irods_reli.o pfs_service_hdfs.o pfs_service_bxgrid.o pfs_service_xrootd.o pfs_service_cvmfs.o
PROGRAMS = parrot_run $(UTILITIES)
HEADERS_PUBLIC = parrot_client.h
SCRIPTS = parrot_identity_box parrot_run_hdfs parrot_package_run chroot_package_run
TARGETS = $(PROGRAMS) $(LIBRARIES)
UTILITIES = parrot_lsalloc parrot_mkalloc parrot_getacl parrot_setacl parrot_whoami parrot_locate parrot_md5 parrot_cp parrot_timeout parrot_search parrot_package_create parrot_debug parrot_mount parrot_namespace

ifeq ($(CCTOOLS_BUILD_LIB64PARROT_HELPER),yes)
 LIBRARIES += lib64/libparrot_helper.$(CCTOOLS_DYNAMIC_SUFFIX)
endif

ifeq ($(CCTOOLS_BUILD_LIB32PARROT_HELPER),yes)
 LIBRARIES += lib/libparrot_helper.$(CCTOOLS_DYNAMIC_SUFFIX)
endif

all: $(TARGETS)

$(OBJECTS): tracer.table.h tracer.table.c tracer.table64.h tracer.table64.c

tracer.table.h tracer.table.c tracer.table64.h tracer.table64.c: tracer.table.pl syscall_parrot.tbl

libparrot_client.a: parrot_client.o

libparrot_helper.$(CCTOOLS_DYNAMIC_SUFFIX): parrot_helper.c

lib64/libparrot_helper.$(CCTOOLS_DYNAMIC_SUFFIX): parrot_helper.c
	mkdir -p lib64
	gcc -m64 -shared -fPIC $< -o $@

lib/libparrot_helper.$(CCTOOLS_DYNAMIC_SUFFIX): parrot_helper.c
	mkdir -p lib
	gcc -m32 -shared -fPIC $< -o $@

tracer.table64.c: syscall_64.tbl
	cat $< syscall_parrot.tbl | perl tracer.table.pl table 64 > $@

tracer.table64.h: syscall_64.tbl
	cat $< syscall_parrot.tbl | perl tracer.table.pl header 64 > $@

tracer.table.c: syscall_32.tbl
	cat $< syscall_parrot.tbl | perl tracer.table.pl table 32  > $@

tracer.table.h: syscall_32.tbl
	cat $< syscall_parrot.tbl | perl tracer.table.pl header 32 > $@

parrot_run: $(OBJECTS_PARROT_RUN) libparrot_client.a
	$(CCTOOLS_CXX) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $^ $(CCTOOLS_IRODS_LDFLAGS) $(CCTOOLS_MYSQL_LDFLAGS) $(CCTOOLS_XROOTD_LDFLAGS) $(CCTOOLS_CVMFS_LDFLAGS) $(CCTOOLS_GLOBUS_LDFLAGS) $(CCTOOLS_EXTERNAL_LINKAGE)

parrot_cvmfs_static_run: $(OBJECTS_PARROT_RUN) libparrot_client.a $(CCTOOLS_CVMFS_LDFLAGS) $(EXTERNAL_DEPENDENCIES)
	$(CCTOOLS_CXX) -static -static-libstdc++ -static-libgcc -o $@ $^ $(CCTOOLS_INTERNAL_LDFLAGS) -Wl,-Bstatic $(CCTOOLS_EXTERNAL_LINKAGE)

irods_reli.o: irods_reli.cc irods_reli.h
	$(CCTOOLS_CXX) -o $@ -c $(CCTOOLS_INTERNAL_CXXFLAGS) $< $(CCTOOLS_IRODS_CCFLAGS)

pfs_service_bxgrid.o: pfs_service_bxgrid.cc
	$(CCTOOLS_CXX) -o $@ -c $(CCTOOLS_INTERNAL_CXXFLAGS) $< $(CCTOOLS_MYSQL_CCFLAGS)

pfs_service_xrootd.o: pfs_service_xrootd.cc
	$(CCTOOLS_CXX) -o $@ -c $(CCTOOLS_INTERNAL_CXXFLAGS) $< $(CCTOOLS_XROOTD_CCFLAGS)

pfs_service_cvmfs.o: pfs_service_cvmfs.cc
	$(CCTOOLS_CXX) -o $@ -c $(CCTOOLS_INTERNAL_CXXFLAGS) $< $(CCTOOLS_CVMFS_CCFLAGS)

pfs_service_ftp.o: pfs_service_ftp.cc
	$(CCTOOLS_CXX) -o $@ -c $(CCTOOLS_INTERNAL_CXXFLAGS) $< $(CCTOOLS_GLOBUS_CCFLAGS)

$(UTILITIES): libparrot_client.a
parrot_namespace: pfs_mountfile.o pfs_resolve_mount.o

$(PROGRAMS): $(EXTERNAL_DEPENDENCIES)

clean:
	rm -f $(OBJECTS) $(TARGETS) $(PROGRAMS) $(LIBRARIES) tracer.table.c tracer.table.h tracer.table64.c tracer.table64.h

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	chmod 755 $(SCRIPTS)
	cp $(PROGRAMS) $(SCRIPTS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(HEADERS_PUBLIC) $(CCTOOLS_INSTALL_DIR)/include/cctools/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
ifeq ($(CCTOOLS_BUILD_LIB64PARROT_HELPER),yes)
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib/lib64
endif
ifeq ($(CCTOOLS_BUILD_LIB32PARROT_HELPER),yes)
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib/lib
endif
	for lib in $(LIBRARIES); do cp $$lib $(CCTOOLS_INSTALL_DIR)/lib/$$lib; done

test: all

.PHONY: all clean install test

=== umbrella/src/Makefile ===
include ../../config.mk
include ../../rules.mk

EXTERNAL_DEPENDENCIES =
LIBRARIES =
OBJECTS =
PROGRAMS = umbrella
SCRIPTS =
TARGETS = $(PROGRAMS) $(LIBRARIES) umbrella_helper.html

all: $(TARGETS)

umbrella: umbrella.py
	sed 's%CCTOOLS_VERSION%${CCTOOLS_VERSION}%' < umbrella.py > umbrella
	chmod 755 umbrella

umbrella_helper.html: umbrella.py
	# pydoc2/pydoc creates a html file, umbrella.html.
	if which pydoc2; then pydoc2 -w umbrella; elif which pydoc; then pydoc -w umbrella; fi
	if [ -f umbrella.html ]; then mv umbrella.html umbrella_helper.html; fi

clean:
	rm -f $(OBJECTS) $(TARGETS)

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(PROGRAMS) $(SCRIPTS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc
	if [ -f umbrella_helper.html ]; then cp umbrella_helper.html $(CCTOOLS_INSTALL_DIR)/doc/; fi

test: all

.PHONY: all clean install test

=== resource_monitor/src/python/Makefile ===
include ../../../config.mk
include ../../../rules.mk

# Python always uses 'so' for its modules (even on Darwin)
CCTOOLS_DYNAMIC_SUFFIX = so
# SWIG produces code that causes a lot of warnings, so use -w to turn those off.
LOCAL_CCFLAGS = -fPIC -w $(CCTOOLS_PYTHON_CCFLAGS)
LOCAL_LINKAGE = $(CCTOOLS_PYTHON_LDFLAGS)

EXTERNAL_DEPENDENCIES = ../../../dttools/src/libdttools.a
RMPYTHONSO = _cResourceMonitor.$(CCTOOLS_DYNAMIC_SUFFIX)
LIBRARIES = $(RMPYTHONSO) cResourceMonitor.py
OBJECTS = rmonitor_wrap.o
TARGETS = $(LIBRARIES)

all: $(TARGETS)

# The odd symlink in the following rule is necessary to overcome a problem
# in the framework search path emitted by the Python configuration on macOS.
rmonitor_wrap.c cResourceMonitor.py: rmonitor.i
	@echo "SWIG rmonitor.i (python)"
	@$(CCTOOLS_SWIG) -o rmonitor_wrap.c -python -I../../../dttools/src/ rmonitor.i
	ln -sf /System/Library/Frameworks/Python.framework .

$(RMPYTHONSO): rmonitor_wrap.o $(EXTERNAL_DEPENDENCIES)

clean:
	rm -f $(OBJECTS) $(TARGETS) Python.framework rmonitor_wrap.c *.so *.pyc

test:

install: all
	mkdir -p $(CCTOOLS_PYTHON_PATH)
	chmod 755 ResourceMonitor.py
	cp ResourceMonitor.py $(TARGETS) $(CCTOOLS_PYTHON_PATH)/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc
	cp rmonitor_allocations_example.py $(CCTOOLS_INSTALL_DIR)/doc/

=== debian/changelog ===
cctools (6.2.10-1) unstable; urgency=medium

  * New upstream release
  * Use xz compression for pkg
  * Add headers to patches
  * Build with support for python3.6, python3.7

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 28 Jun 2018 15:35:58 +0100

cctools (6.2.9-6) unstable; urgency=medium

  * More work needed on SYS_openat.patch for Arm64 support

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Jun 2018 09:40:17 +0100

cctools (6.2.9-5) unstable; urgency=medium

  * Fix multiarch triplet detection (use dpkg-printarchitecture)
  * Typo in sys_openat patch

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Jun 2018 17:02:18 +0100

cctools (6.2.9-4) unstable; urgency=medium

  * Re-enable multiarch_configure patch
  * Remove obsolete patch parrot_run_hang_fix
  * Add 64-bit detection for globus gcc64 flavor

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 12 Jun 2018 20:03:15 +0100

cctools (6.2.9-3) unstable; urgency=medium

  * Add SYS_openat support for arm64 arch
  * Drop explicit path for --with-mysql-path as it breaks on M-A.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 11 Jun 2018 19:56:57 +0100

## cctools 7.0.0

=== debian/changelog ===
cctools (7.0.0-1build1) disco; urgency=medium

  * No-change rebuild to build without python3.6 support.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 03 Nov 2018 12:06:22 +0000

cctools (7.0.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 09 Jul 2018 09:22:21 +0100

## cctools 7.0.8

=== debian/changelog ===
cctools (7.0.8-1) unstable; urgency=medium

  * New upstream release
  * Enable verbose build by default for glibc-2.28 transition.
    Closes: #913059
  * perl-path patch: Call 'usr/bin/perl' not 'env perl'

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 08 Nov 2018 12:09:15 +0000
